#include "ball.h"
#include "string.h"
#include <QDebug>

Ball::Ball(double m, float radius, Cartesian location, Cartesian v) :
        Mass(m),
        r(radius),
        Location(location),
        Velocity(v)
{
}

void Ball::affect(IFObjHeader *obj, double timeStep) {
    if ( strcmp(obj->getObjType(), "ball") == 0 ) {
        collideBallToBall(obj, timeStep);
    }
    if ( strcmp(obj->getObjType(), "wall") == 0 ) {
        collideBallToWall(obj, timeStep);
    }
}

void Ball::sync(double timeStepForMove) {
    syncMass();
    syncLocation();
    syncVelocity();

    moveBall(timeStepForMove);

    syncMass();
    syncLocation();     //// ????? Doesn't affect
    syncVelocity();
    qDebug("sync");  /// sssss
}


void Ball::moveBall(double timeStepForMove) {
    setLocationX( getLocation().getX() + timeStepForMove*getVelociy().getX() ) ;
    setLocationY( getLocation().getY() + timeStepForMove*getVelociy().getY() ) ;
    setVelocityY( getVelociy().getY() - 0.0001 ); // Gravity acceleration on Y axis
    setLocationZ( getLocation().getZ() + timeStepForMove*getVelociy().getZ() ) ;
}

void Ball::collideBallToBall(IFObjHeader *obj, double timeStep) {
    /// TODO!!
}

void Ball::collideBallToWall(IFObjHeader *obj, double timeStep) {
    if ( strcmp(obj->getObjType(), "wall") == 0) {
        /// TODO!!!
    }
}
