#ifndef BALL_H
#define BALL_H
#include "cartesian.h"
#include "mass.h"
#include "velocity.h"
#include "location.h"
#include "ifobjheader.h"

class Ball : public Mass, public Location, public Velocity, public IFObjHeader
{
private:
    void moveBall(double timeStepForMove);
    void collideBallToBall(IFObjHeader *obj, double timeStep);
    void collideBallToWall(IFObjHeader *obj, double timeStep);
    float r;    // radius
public:
    Ball(double m, float radius, Cartesian location, Cartesian v);
    char *getObjType() {return "ball";} //IFObjHeader
    void affect(IFObjHeader *obj, double timeStep);  //IFObjHeader here are list of performed affections
    void sync(double timeStepForMove);    //IFObjHeader
    float getR() {return r;}
    void setR(float r) { this->r = r; }


};

#endif // BALL_H
