#include "mainwindow.h"
#include "ui_mainwindow.h"
#include <QTimer>
#include "ball.h"
#include "sheet.h"

MainWindow::MainWindow(QWidget *parent)
    : QMainWindow(parent), ui(new Ui::MainWindow)
{
    timer = new QTimer(this);
    ui->setupUi(this);
    Ball *ball1 = new Ball( 1, 8, Cartesian(1, 1, -50), Cartesian(0.1, 0, 0) );
    Ball *ball2 = new Ball( 2, 3, Cartesian(1, 2, -50), Cartesian(0, 0, 0) );
    Ball *ball3 = new Ball( 3, 1, Cartesian(2, 2, -50), Cartesian(0, 0, 0.1) );
    Sheet *sheet1 = new Sheet( Location( Cartesian(1,1,1) ),
                               Location( Cartesian(1,1,-10) ),
                               Location( Cartesian(10,1,-10) ),
                               Location( Cartesian(10,1,1) )
                              );
    objsConn.addObj( sheet1 );
    objsConn.addObj( ball1 );
    objsConn.addObj( ball2 );
    objsConn.addObj( ball3 );
    objsConn.setTimeStep(1);
    ui->simulationView->setModel(&objsConn);
    objsConn.setView( (IFSlotTime *)ui->simulationView );
    connect(timer, SIGNAL(timeout()), this, SLOT(slotTime()));
    list<IFObjHeader *>::iterator iter;    // general purpose obj list iterator
    list<IFObjHeader *> *list = objsConn.getObjsList();
    iter = list->begin();

    double mm = ( (Ball *)*iter )->getMass();
    iter++;
   // mm =
    ( (Ball *)*iter )->getMass();
    iter++;
   // mm = ( (Ball *)*iter )->getMass();

}

void MainWindow::slotTime() {
    objsConn.slotTime();
    qDebug("time");
}

MainWindow::~MainWindow()
{
    delete ui;
}

void MainWindow::on_pushButton_clicked()
{
    timer->start(0.1);
}

void MainWindow::on_pushButtonStop_clicked()
{
    timer->stop();
}
