#ifndef WIDGETSIMULATIONVIEW_H
#define WIDGETSIMULATIONVIEW_H

#include <QGLWidget>
#include <QTime>
#include <QTimer>
#include "objsconnections.h"
#include "ball.h"
using namespace std;


class WidgetSimulationView : public QGLWidget, public IFSlotTime
{
    Q_OBJECT
public:
    WidgetSimulationView(QWidget *parent);
    void setModel( ObjsConnections *conn) { modelObjsList = conn->getObjsList(); }
    void slotTime();
protected:
    void initializeGL();
    void resizeGL(int w, int h);
    void paintGL();
private:
    QTimer *timer;
    QTime time;
    GLuint filter, texture[3];
    GLfloat xrot, yrot, xspeed, yspeed, z;
    bool lightChanged, filterChanged, objChanged;
    int changeAmount;
    GLUquadricObj *quadricObj;
    unsigned int object;
    int part1, part2, p1, p2;
    void drawCube();
    list<IFObjHeader *> *modelObjsList;
    list<IFObjHeader *>::iterator iter;    // general purpose obj list iterator
};

#endif // WIDGETSIMULATIONVIEW_H
